;--------------------------------------------------------------------------
; Fonction C destine  retourner le segment  de la mmoire vido, si
; l'utilisateur tourne sous desqview.
;
; Retourne le segment  inchang si il n'y a pas desqview.
;
; Routine assembleur aimablement passe par Franois Bergeon.
;
;            unsigned deskvideo( unsigned original_segment ) ;
;
;
;-------------------------------------------------------------------------

DESQVIDEO_TEXT   segment byte public 'CODE'
                 assume  cs:DESQVIDEO_TEXT

_desqvideo       proc    far
	push	bp
	mov	bp,sp

        mov     ax,word ptr [bp+6]       ;  Rcupre le segment vido.
        push    ax

        mov     cx, 'DE'
        mov     dx, 'SQ'
        mov     ax, 02b01h
        int     21h
;
        mov     ah, al
        inc     ax              ; if al = 0ffh, no DESQview
        jz      no_desqview
;
        pop     ax
        mov     ah, 0feh        ; get video buffer segment in es
        int     10h
        push    es
;
no_desqview:
        pop     ax              ; ax contains video buffer segment

	pop	bp
	ret	
_desqvideo       endp

        public  _desqvideo

DESQVIDEO_TEXT   ends
END
;------------------------------------------------------------------------
