/*--------------------------------------------------------------------------*/
/*
   GENIMAGE   -  Ren Cougnenc 1990 -     Petit utilitaire perso...
   -----------------------------------------------------------------

       Gnration  partir d'une image code ansi d'un source assembleur,
       affichant cette image a l'ecran.

       Le code gnr sera inclus DANS le segment de CODE d'un programme C
       au linkage. (le segment de data n'est pas touch).

       Ceci pour utiliser des datas en modele Large du turbo-C...


       L'analyse se fait par le driver ansi du DOS.
       Tous les 4000 octets de l'ecran sont inclus.
*/


#ifndef __TURBOC__
#error  Il y a des trucs spcifiques  Turbo-C dans ce source... Dsol...
#endif


#include <dos.h>
#include <stdio.h>
#include <conio.h>

#define printf cprintf
#define puts   cputs

unsigned char far *Ecran  ; /*  = MK_FP (0xB800,0x0000);*/
unsigned char BufEcran[4000];

FILE *fichier;

main(int argc,char **argv)
{
 char ch;
 int i,mode;
 union REGS regs;
 char Commande[127];   /* pour appeler l'assembleur direct */

 directvideo =1;
 if(argc < 3) usage();

 
  regs.h.ah = 0x0F;
  int86(0x10,&regs,&regs);
  mode=regs.h.al;
  if( mode == 7 ) Ecran = MK_FP (0xB000,0x0000);
  else Ecran = MK_FP (0xB800,0x0000);

 fichier = fopen(argv[1],"rb");
 if( fichier == NULL) usage();
 while(fread(&ch,1,1,fichier))
  {
    putchar(ch);   /* Affiche l'image ansi. */
  }
 fclose(fichier);

for(i=0;i<4000;i++) BufEcran[i] = *(Ecran+i);
fichier = fopen(argv[2],"wt");
if( fichier == NULL) usage();

putchar(27);       /* vire les attributs ansi qui pourraient rester */
putchar('[');
putchar('0');
putchar('m');

printf("Gnration du fichier assembleur...\n");
       Entete();
       Codage();
       Finale();
       fclose(fichier);

printf("Ca y est, le fichier %s est ralis.\n",argv[2]);
printf("Ce source est  assembler avec la commande MASM /mx   %s\n\n",argv[2]);
sprintf(Commande,"MASM /mx %s;",argv[2]);
system(Commande);
printf("\n\nLa fonction  appeler en langage C se nomme:\n\n");
printf(" void Image(unsigned char far *Adresse_Ecran)\n");
}

usage()
{
   printf("\n        GENIMAGE - [Ren Cougnenc 1990]\n\n");
   printf("        Syntaxe : Genimage fichier_ANSI  source_ASSEMBLEUR.\n");
   printf("        Va afficher  une  image ansi, puis  gnrer un source  assembleur\n");
   printf("        ralisant une fonction  C  qui affiche  seule cette  image vido.\n\n");
   printf("        Attention,ce programme utilise ANSI.SYS pour simplifier l'analyse\n\n");
   printf("        de l'cran,(la fonction n'en a pas besoin ensuite bien sr...\n\n");
   exit(0);
}

Entete()       /* Prologue assembleur a la fonction C */
{
fprintf(fichier,";----------------------------------------------------------------------------\n");
fprintf(fichier,";    Affichage d'une image en mmoire vido, cette image \n");
fprintf(fichier,";    tant contenue dans le segment de CODE d'un programme\n");
fprintf(fichier,";    C compil en large model.\n");
fprintf(fichier,";\n");
fprintf(fichier,";    La fonction ainsi implmente sera appele ainsi:\n");
fprintf(fichier,";\n");
fprintf(fichier,";    void Image(unsigned char far *Memoire_video)\n");
fprintf(fichier,";\n");
fprintf(fichier,";    (un pointeur sur la memoire mono ou couleur)\n");
fprintf(fichier,";\n");
fprintf(fichier,";    Ce fichier a t ralis avec GENIMAGE.EXE [R Cougnenc 90]\n");
fprintf(fichier,";----------------------------------------------------------------------------\n");
fprintf(fichier,";    Assemblage: masm /mx     (case sensitive pour le C!!!)\n");
fprintf(fichier,";----------------------------------------------------------------------------\n");


   fprintf(fichier,"    IMAGE_TEXT    segment  byte public 'CODE'\n");
   fprintf(fichier,"                  assume cs:IMAGE_TEXT\n\n");
}


Finale()
{
  fprintf(fichier,"         pop    bp\n");
  fprintf(fichier,"         pop    si\n");
  fprintf(fichier,"       RET\n");
  fprintf(fichier,"     _Image  endp\n\n");

  fprintf(fichier,"       public    _Image\n");
  fprintf(fichier,"    IMAGE_TEXT   ends\n     END\n");
  fprintf(fichier,";-----------------------------------------------------------------------------\n");
}


Codage()
{
int i,j;
unsigned char ch;

fprintf(fichier," Valeurs label byte\n");

j=0;
fprintf(fichier,"       db   ");
for(i=0;i< 4000;i++)
   {
    if( j < 15)
      fprintf(fichier,"%03d,",BufEcran[i]);
    else
      fprintf(fichier,"%03d\n",BufEcran[i]);
    j++;
    if( j > 15)
      {
       j=0;
       fprintf(fichier,"       db   ");
      }
   }                              /* Ici la fonction en elle meme */

  fprintf(fichier,"0\n\n\n");
  fprintf(fichier,"     _Image  PROC  FAR         ; Modele memoire large\n");
  fprintf(fichier,"        push   si\n");
  fprintf(fichier,"        push   bp\n");
  fprintf(fichier,"        mov    bp,sp\n");
  fprintf(fichier,"        xor    si,si           ;compteur  zro.\n\n");
  fprintf(fichier,"        les    bx,dword ptr [bp+8]\n");
  fprintf(fichier,"  encore:\n");
  fprintf(fichier,"          mov    al,  byte ptr[valeurs + si]\n");
  fprintf(fichier,"          mov    byte ptr es:[bx+si],al\n");
  fprintf(fichier,"          inc    si\n");
  fprintf(fichier,"          cmp    al, 0\n");
  fprintf(fichier,"          jnz    encore\n\n");
}
