#
#                  Make-file pour systme de dveloppement Microsoft
#
# Ŀ
#  ͻ 
#                                                                         
#                  BBTH VERSION 1.18-Decembre 89                          
#                  ----------------------------                           
#                                                                         
#                                                                         
#  ͼ 
# 
#
#        Attention, utilisation du compacteur de *.exe de fab: LZEXE
#
#   Dfinition des macros
#
#
#
#        Nom des processeurs
#
CC     = cl
AS     = masm
LK     = link


#
#       Options des processeurs
#
#       Si une option doit tre change, c'est ici qu'il faut le faire
#
#       L'option /Zp1 du compilateur est Obligatoire pour le module ASM...
#
ASFLAGS = /mx
CFLAGS  = /AL /c /Zp1  /Oails /Gs
LKFLAGS = /NOI /B /PAC /F
LKLIB   =


#
#       Rgles d'infrences standard
#
.asm.obj:
       $(AS) $(ASFLAGS) $*.asm;

.c.obj:
       $(CC) $(CFLAGS) $*.c

#
#       Infrences implicites
#
bbth.obj:     bbth.c bbth.h commpkg.h config.h couleurs.h

commpkg.obj:  commpkg.c commpkg.h

com_unit.obj: com_unit.asm

config.obj:   config.c config.h touches.h

confscr.obj:  confscr.c confscr.h config.h

clavecra.obj: clavecra.c clavecra.h touches.h couleurs.h config.h

printer.obj:  printer.c printer.h

ansiterm.obj: ansiterm.c ansiterm.h config.h touches.h

minitel.obj:  minitel.c minitel.h config.h touches.h couleurs.h

bbt.obj:      bbt.c bbt.h config.h touches.h config.h couleurs.h

xymodem.obj:  xymodem.c xymodem.h config.h touches.h couleurs.h

updown.obj:   updown.c  updown.h config.h touches.h couleurs.h

kortex.obj:   kortex.c  kortex.h config.h

retourne.obj: retourne.c  retourne.h config.h

system.obj:   system.c system.h

backview.obj: backview.c  backview.h

fonction.obj: fonction.c fonction.h config.h touches.h couleurs.h

qnxterm.obj:  qnxterm.c qnxterm.h couleurs.h touches.h

calendri.obj: calendri.c

cacatel.obj:  cacatel.c cacatel.h commpkg.h config.h

souris.obj:   souris.c souris.h config.h

musique.obj:  musique.c musique.h config.h

zmenvoi.obj:  zmenvoi.c zmodem.h config.h

zmrecep.obj:  zmrecep.c zmodem.h config.h

zmprim.obj :  zmprim.c  zmodem.h config.h

jmodem.obj:   jmodem.c  jmodem.h

rigodate.obj: rigodate.asm

linecomm.obj: linecomm.c linecomm.h

desqtest.obj: desqtest.asm


# -- programmes annexes

install.obj: install.c config.h

perso.obj:   perso.c   config.h

reinst.obj:  reinst.c config.h

patch.obj :  patch.c
#
#       Infrences explicites
#

install.exe: install.obj
  $(LK) $(LKFLAGS) install, install.exe, NUL,$(LKLIB);

perso.exe: perso.obj
  $(LK) $(LKFLAGS) perso, perso.exe, NUL,$(LKLIB);

reinst.exe: reinst.obj
  $(LK) $(LKFLAGS) reinst, reinst.exe, NUL,$(LKLIB);

patch.exe: patch.obj
  $(LK) $(LKFLAGS) patch, patch.exe, NUL,$(LKLIB);

bbth.exe: bbth.obj commpkg.obj com_unit.obj config.obj clavecra.obj \
          printer.obj  ansiterm.obj minitel.obj bbt.obj xymodem.obj \
          updown.obj kortex.obj retourne.obj system.obj fonction.obj \
          backview.obj qnxterm.obj calendri.obj cacatel.obj souris.obj \
          confscr.obj musique.obj zmenvoi.obj zmrecep.obj zmprim.obj \
          jmodem.obj rigodate.obj linecomm.obj desqtest.asm install.c
  $(LK) $(LKFLAGS) @linkfile, bbth.exe, NUL, $(LKLIB);
#  lzexe   bbth
  pklite  bbth.exe
  patch   bbth.exe
  install bbth.exe
#  reinst  bbth.exe
#  del bbth.old
# exepack bbth.tmp bbth.exe
# install bbth.exe
# del bbth.tmp
#-------------------------fin du makefile------------------------------------


