;----------------------------------------------------------------------------
; Fonction C   Rigodate()                                Ren Cougnenc 1990
;----------------------------------------------------------------------------
;    Affichage directement en mmoire vido d'un message correspondant
;     la date du jour, si celle ci est soit Noel, soit le Nouvel AN,
;    Soit le Premier Avril.
;
;    Si l'anne n'est pas plausible ( < 1990) c'est prvu aussi :-)
;
;    Destin  tre appel depuis un programme C compil en large model
;    de la mainre suivante:
;
;    void Rigodate(unsigned char far *Memoire_video)
;
;    (un pointeur sur la mmoire mono ou couleur)
;
;    TOUT est plac dans le SEGMENT de CODE:  RIGODATE_TEXT
;----------------------------------------------------------------------------
;    Assemblage: masm /mx     (case sensitive pour le C!!!)
;    Macro-Assembleur masm 4.0 Microsoft.
;----------------------------------------------------------------------------

POSITION   EQU  94     ; Position sur l'cran. (Offset dans mmoire vido)
                       ; Doit tre toujours paire. (caractere/attribut...)
                       ; Ici 96 met tout en haut a droite de l'ecran.

RIGODATE_TEXT    segment  byte public 'CODE'
                 assume cs:RIGODATE_TEXT


 Ligne1 label byte   ;------ Ligne du haut de la boite.Cadre Blanc,fond rouge

       db   219,079,223,079,223,079,223,079,223,079,223,079,223,079,223,079
       db   223,079,223,079,223,079,223,079,223,079,223,079,223,079,223,079
       db   223,079,223,079,223,079,223,079,223,079,223,079,223,079,223,079
       db   223,079,223,079,223,079,223,079,223,079,223,079,223,079,219,079
       db   0

Ligne2 label byte    ;----- Lignes du milieu de la boite.

       db   219,079,032,079,032,079,032,079,032,079,032,079,032,079,032,079
       db   032,079,032,079,032,079,032,079,032,079,032,079,032,079,032,079
       db   032,079,032,079,032,079,032,079,032,079,032,079,032,079,032,079
       db   032,079,032,079,032,079,032,079,032,079,032,079,032,079,219,079
       db   0


Ligne3 label byte    ;----- Ligne du Bas de la boite .

       db   219,079,220,079,220,079,220,079,220,079,220,079,220,079,220,079
       db   220,079,220,079,220,079,220,079,220,079,220,079,220,079,220,079
       db   220,079,220,079,220,079,220,079,220,079,220,079,220,079,220,079
       db   220,079,220,079,220,079,220,079,220,079,220,079,220,079,219,079
       db   0

Txt1  db 50 dup (0)
Txt2  db 50 dup (0)

;-------------- Les messages pour chaque date -----------

Msg0A  db  'Cher ami,vu la date systme',0
Msg0B  db  'vous vivez dans le pass  !',0

Msg1A  db  'Premier Avril !!!',0
Msg1B  db  'Mfiez-vous des poissons...',0

Msg2A  db  '25 Dcembre...',0
Msg2B  db  'Joyeux Nol,mon vieux !!!',0

Msg3A  db  'Bonne  Anne !',0
Msg3B  db  'Et  ta sant...    Hips!',0

Msg4A  db  '1er Mai, Fte du Travail !',0
Msg4B  db  'Coupez moi cet ordinateur!',0

Msg5A  db  '14 Juillet... La prise de',0
Msg5B  db  'la Bastille,du 220 Volts?',0

Msg6A  db  'Comment ? Vous tes encore',0
Msg6B  db  'l dessus le 15 Aot vous?',0
;--------------------------------------------------------

    _Rigodate  PROC  FAR         ; Modele memoire large
        push   si
        push   bp
        mov    bp,sp
        xor    si,si           ;compteur  zro.



        mov    ah,2AH
        int    21H                       ; recupere la date systeme

                                         ;<---- TEST de L'ANNEE ICI !!! ----
        cmp    CX, 1990                  ; avant c'est le pass !
        jae    Avril                     ; a va il est a l'heure lui

       xor    si,si                      ; Copie du message dans Texte.
DateA: mov    al, byte ptr[Msg0A + si]   ;( vous vivez dans le pass...)
       mov    byte ptr[Txt1+si],al
       inc    si
       cmp    al, 0
       jnz    DateA
       xor    si,si
DateB: mov    al, byte ptr[Msg0B + si]
       mov    byte ptr[Txt2+si],al
       inc    si
       cmp    al, 0
       jnz    DateB
       jmp    Boite


Avril:
       cmp    dh, 4                      ; mois d'avril ?
       jnz    Noel
       cmp    dl, 1                      ; premier avril ?
       jnz    Noel
       xor    si,si                      ; Copie du message dans Texte.
AvA:   mov    al, byte ptr[Msg1A + si]
       mov    byte ptr[Txt1+si],al
       inc    si
       cmp    al, 0
       jnz    AvA
       xor    si,si
AvB:   mov    al, byte ptr[Msg1B + si]
       mov    byte ptr[Txt2+si],al
       inc    si
       cmp    al, 0
       jnz    AvB
       jmp    Boite


Noel :                                   ; Pareil pour  Noel:
       cmp    dh, 12                     ; mois de decembre ?
       jnz    Annee
       cmp    dl, 25                     ; le 25 decembre ?
       jnz    Annee
       xor    si,si
NoA:   mov    al, byte ptr[Msg2A + si]
       mov    byte ptr[Txt1+si],al
       inc    si
       cmp    al, 0
       jnz    NoA
       xor    si,si
NoB:   mov    al, byte ptr[Msg2B + si]
       mov    byte ptr[Txt2+si],al
       inc    si
       cmp    al, 0
       jnz    NoB
       jmp    Boite

Annee:                                   ;Et pareil pour le nouvel an.
       cmp    dh, 1                      ; mois de Janvier  ?
       jnz    Mai
       cmp    dl, 1                      ; le Premier Janvier ?
       jnz    Mai
       xor    si,si
DeA:   mov    al, byte ptr[Msg3A + si]
       mov    byte ptr[Txt1+si],al
       inc    si
       cmp    al, 0
       jnz    DeA
       xor    si,si
DeB:   mov    al, byte ptr[Msg3B + si]
       mov    byte ptr[Txt2+si],al
       inc    si
       cmp    al, 0
       jnz    DeB
       jmp    Boite

Mai :                                   ;Et pareil pour le premier mai
       cmp    dh, 5                      ; mois de Mai ?
       jnz    Jui
       cmp    dl, 1                      ; le Premier Mai ?
       jnz    Jui
       xor    si,si
MaA:   mov    al, byte ptr[Msg4A + si]
       mov    byte ptr[Txt1+si],al
       inc    si
       cmp    al, 0
       jnz    MaA
       xor    si,si
MaB:   mov    al, byte ptr[Msg4B + si]
       mov    byte ptr[Txt2+si],al
       inc    si
       cmp    al, 0
       jnz    MaB
       jmp    Boite


Jui :                                    ;Et pareil pour le 14 Juillet
       cmp    dh, 7                      ; mois de Juillet  ?
       jnz    Aug
       cmp    dl, 14                     ; le 14 Juillet ?
       jnz    Fin
       xor    si,si
JuA:   mov    al, byte ptr[Msg5A + si]
       mov    byte ptr[Txt1+si],al
       inc    si
       cmp    al, 0
       jnz    JuA
       xor    si,si
JuB:   mov    al, byte ptr[Msg5B + si]
       mov    byte ptr[Txt2+si],al
       inc    si
       cmp    al, 0
       jnz    JuB
       jmp    Boite

Aug :                                    ;Et pareil pour le 15 Aout
       cmp    dh, 8                      ; mois de Aout     ?
       jnz    Fin
       cmp    dl, 15                     ; le 15 Aout    ?
       jnz    Fin
       xor    si,si
AuA:   mov    al, byte ptr[Msg6A + si]
       mov    byte ptr[Txt1+si],al
       inc    si
       cmp    al, 0
       jnz    AuA
       xor    si,si
AuB:   mov    al, byte ptr[Msg6B + si]
       mov    byte ptr[Txt2+si],al
       inc    si
       cmp    al, 0
       jnz    AuB
       jmp    Boite

Fin:   jmp Termine

Boite:                                ;---- Dessin de la boite ---------

        les    bx,dword ptr [bp+8]    ;pointeur mmoire cran
        xor si,si                     ;compteur  zro
 encore1:
          mov    al,  byte ptr[Ligne1 + si] ;   Premire ligne boite
          mov    byte ptr es:[bx+si+POSITION],al
          inc    si
          cmp    al, 0
          jnz    encore1

          xor si,si
 encore2:
          mov    al,  byte ptr[Ligne2 + si] ;   Deuxieme ligne boite
          mov    byte ptr es:[bx+si+160+POSITION],al
          inc    si
          cmp    al, 0
          jnz    encore2

          xor si,si
 encore3:
          mov    al,  byte ptr[Ligne2 + si] ;  Troisime ligne boite
          mov    byte ptr es:[bx+si+320+POSITION],al
          inc    si
          cmp    al, 0
          jnz    encore3

          xor si,si
 encore4:
          mov    al,  byte ptr[Ligne3 + si] ;  Derniere ligne boite
          mov    byte ptr es:[bx+si+480+POSITION],al
          inc    si
          cmp    al, 0
          jnz    encore4
                                            ;---- La boite est dessinee.
          xor si,si                         ; Compteurs  Zro.
          xor di,di

Texte1:                                     ; Premiere ligne message.
          mov    al,  byte ptr[Txt1 + si]
          mov    byte ptr es:[bx+di+166+POSITION],al ; La lettre
          inc    di
          mov    byte ptr es:[bx+di+166+POSITION],78 ; L'attrtibut couleur Jaune
          inc    si
          inc    di
          cmp    al, 0
          jnz    Texte1

          xor si,si                         ; compteurs  zero.
          xor di,di

Texte2:                                     ; Seconde ligne message.
          mov    al,  byte ptr[Txt2 + si]
          mov    byte ptr es:[bx+di+326+POSITION],al ; La lettre
          inc    di
          mov    byte ptr es:[bx+di+326+POSITION],78 ; L'attrtibut couleur Jaune
          inc    si
          inc    di
          cmp    al, 0
          jnz    Texte2


Termine:

         pop    bp
         pop    si
       RET
    _Rigodate  endp

       public    _Rigodate
  RIGODATE_TEXT   ends
     END
;-----------------------------------------------------------------------------
