/*
   Ŀ
   Ŀ
    BbtH                                                               
          Dclarations du module xymodem.C                       
                                                                        
   ٳ
   
*/

#define NUL 0x00
#define SOH 0x01
#define STX 0x02
#define EOT 0x04
#define ACK 0x06
#define BEL 0x07
#define NAK 0x15
#define CAK 0x43
#define CAN 0x18


#define WAIT_TIME      2   /* Temps max qutorise entre 2 caracteres */
#define MAXERREURS    10   /* Nombre d'erreurs maximum de ci dessus */
#define MAXBLOCERRORS 10   /* Nombre max de retries d'un meme bloc  */
#define MAXTOTERRORS  30   /* Nombre maximum d'erreurs en tout      */
#define RECEPTION      0
#define EMISSION       1


  void XmodemBox(unsigned char mode);
  void XmodemMsg(unsigned char *texte);
  int RecupChar(int maxdelay,int maxerreurs);
  void PurgeLine(void );
  int calcrc(char *ptr,int count);
  int Xmodem_Receive(int taillebloc,int fichier);
  int Xmodem_Send(int taillebloc,int fichier);
