/*
  ͻ
                                                                         
             DOMAINE     IBM-PC   MS-DOS(3.x+)       
                            PUBLIC                                 
                 Ren   Le protocole de Transfert BBT  
                          Cougnenc est de Jean-Claude Michot.     
                1989   La librairie de Comm.est de    
                                          Jean-Pierre Parisy & R.Gillmann
  Ķ
                                                                          
                    MODULE: ZMENVOI : Envoi Zmodem                        
                    -------------------------------                       
                                                                          
      Envoi de fichiers (Batch) sous Zmodem ou Ymodem Batch.              
                                                                          
      Sources de Zmodem-90 de Chuck Forsberg,Profondment adaptes pour   
      Le PC et BBTH ! (Fonctions en moins et en plus !)                   
                                                                          
      Comprend la gestion des Variable Length Headers et du Run Length    
      Encoding des sous paquets.                                          
                                                                          
      Un Grand merci  Florent Pillet qui a port les sources de la ver-  
      sion 1987 sur Atari, ce qui m'a permis de piger plein de trucs :-)  
                                                                          
   Compilation: modle mmoire LARGE                                      
  Ķ
                                                                          
   Ces sources ne sont plus dans le domaine public,vu le boulot faudrait  
   pas dconner.                                                          
                                                                          
   Ceux qui voudraient un zmodem  eux n'ont qu' aller chercher les      
   sources unix de Forsberg et se taper tout le boulot comme les copains! 
                                                                          
  ͼ
  Ŀ
   BbtH 1.2 
  
*/
/*--------------------------------------------------------*/
#ifndef __TURBOC__   /* Borland Turbo-c 1.5               */
#ifndef MSDOS        /* Microsoft C                       */
#error Mfiance ! je ne connais pas ce compilateur l...
#endif
#endif
/*--------------------------------------------------------*/

 /* #define VERSION "sz 3.07 2-02-90"
 ****************************************************************************
 *
 *              sz.c By Chuck Forsberg,  Omen Technology INC
 *
 ****************************************************************************
 *
 * A program for Unix to send files and commands to computers running
 *  Professional-YAM, PowerCom, YAM, IMP, or programs supporting Y/XMODEM.
 *
 *  Sz uses buffered I/O to greatly reduce CPU time compared to UMODEM.
 *
 *  USG UNIX (3.0) ioctl conventions courtesy Jeff Martin
 *
 *
 *	This version implements numerous enhancements including ZMODEM
 *	Run Length Encoding and variable length headers.  These
 *	features were not funded by the original Telenet development
 *	contract.
 *
 * This software may be freely used for non commercial and
 * educational (didactic only) purposes.  This software may also
 * be freely used to support file transfer operations to or from
 * licensed Omen Technology products.  Any programs which use
 * part or all of this software must be provided in source form
 * with this notice intact except by written permission from Omen
 * Technology Incorporated.
 *
 * Use of this software for commercial or administrative purposes
 * except when exclusively limited to interfacing Omen Technology
 * products requires a per port license payment of $20.00 US per
 * port (less in quantity).  Use of this code by inclusion,
 * decompilation, reverse engineering or any other means
 * constitutes agreement to these conditions and acceptance of
 * liability to license the materials and payment of reasonable
 * legal costs necessary to enforce this license agreement.
 *
 *
 *		Omen Technology Inc		FAX: 503-621-3745
 *		Post Office Box 4681
 *		Portland OR 97208
 *
 *	This code is made available in the hope it will be useful,
 *	BUT WITHOUT ANY WARRANTY OF ANY KIND OR LIABILITY FOR ANY
 *	DAMAGES OF ANY KIND.
 *
 *
 *  2.1x hacks to avoid VMS fseek() bogosity, allow input from pipe
 *     -DBADSEEK -DTXBSIZE=32768
 *  2.x has mods for VMS flavor
 *
 * 1.34 implements tx backchannel garbage count and ZCRCW after ZRPOS
 * in accordance with the 7-31-87 ZMODEM Protocol Description
 */

#define READCHECK

#include <stdio.h>
#include <string.h>
#include <setjmp.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "bbth.h"
#include "config.h"
#include "touches.h"
#include "system.h"


#include "zmodem.h"
#include "couleurs.h"


unsigned char Liste_Files[MAXFILES][MAX_PATH]; /* Expansion fichiers   */

/*
 * DOSZ: driver principal pour rediriger sur la reception
 * X/Y/Zmodem et ouvrir les bonnes boiboites.
 * ------------------------------------------------------
 */
void dosz(type)
short type;                             /* 0=Zmodem, 1=Ymodem, 2=Xmodem */
{
        short nfiles;                   /* nombre de fichiers a transmettre */
        int test;                       /* resultat saisie noms fichiers    */

        unsigned char Nom_Fichier[MAX_PATH];

        do_send = TRUE;

        switch(type)
        {
                case 0:                  /* ZMODEM */

                        Blklen  = KSIZE;
                        Lzconv  = 0;
                        Lzmanag = 0;
                        Lzconv = ZCBIN;   /* Transfert Binaire           */
                        Fullname = 0;     /*ON n'envoie pas tout le path */
                        Lzconv = ZCRESUM; /* On gere la reprise          */
                        Lzmanag = (Lzmanag < ZMMASK) | ZMCRC;
                        /*      Lzmanag = ZMPROT; on protege pas         */
                        /*      Lzmanag = ZMNEWL;   pas de mode append!  */
                        /*      Lzconv = ZCNL;      pas de mode azscii   */

                        Lztrans   = ZTRLE; /* RLE encoding               */
                        Wantfcs32 = TRUE;  /* want to send 32 bit FCS        */
                        DoXmodem  = FALSE;
                        Nozmodem  = FALSE;
                        Batch     = TRUE;
                        Crcflg    = TRUE;
                        Zrwindow  = 1400; /* fenetre de reception de paquets */
                        Recover   = 0L;

                     /*----------- saisie du nom de fichier -----------------*/
                     box(5,10,70,14,blanc_bleu);
                     mwrite(7,10," Fichier(s)  envoyer sous Z-MODEM ",Inverse);
                     mwrite(6,13,"[ Un ou plusieurs noms de fichier. '*' et '?' accepts. ]"
                                                                  ,blanc_bleu);
                     strcpy(Nom_Fichier,Config.UpDir);/* rajout du path upload */
                     test=saisie(6,12,Nom_Fichier,blanc_bleu,63,KEEP);
                     if((!*Nom_Fichier)||test==ESC) /* Rien de saisi */
                        return;
                     /*-----------------------------------------------------*/
                     rendecran();
                     sauvecran();
                     curseur(0);
                     nfiles = expand(Nom_Fichier);

                        /* titre de la fenetre de transfert */
                        ZmodemBox();
                        mwrite(28,8,"     ENVOI Z-MODEM     ",Inverse);
                        break;


                case 1:                         /* YMODEM */
                        DoXmodem = FALSE;
                        Nozmodem = TRUE;
                        Batch    = TRUE;
                        Fullname = FALSE;
                        Blklen   = 1024;
                        Fullname = FALSE;
                        Crcflg   = TRUE;
                        Lzconv   = ZCBIN;
                        Lzmanag  = 0;
                        Recover  = 0L;

                     /*----------- saisie du nom de fichier -----------------*/
                     box(5,10,70,14,blanc_bleu);
                     mwrite(7,10," Fichier(s)  envoyer sous Y-MODEM BATCH",Inverse);
                     mwrite(6,13,"[ Un ou plusieurs noms de fichier. '*' et '?' accepts. ]"
                                                                  ,blanc_bleu);
                     strcpy(Nom_Fichier,Config.UpDir);/* rajout du path upload */
                     test=saisie(6,12,Nom_Fichier,blanc_bleu,63,KEEP);
                     if((!*Nom_Fichier)||test==ESC) /* Rien de saisi */
                         return;
                     /*------------------------------------------------------*/
                      rendecran();
                      sauvecran();
                      curseur(0);

                      nfiles = expand(Nom_Fichier);
                        /* titre de la fenetre de transfert */
                        ZmodemBox();
                        mwrite(28,8,"  ENVOI Y-MODEM Batch  ",Inverse);
                        break;

#ifdef __XMODEM__
                case 2:                  /* XMODEM */

                        /* initialise les variables de sz */
                    /*----
                        Blklen = config.ymodem.blklen ? KSIZE : SECSIZ;
                        Ascii = config.ymodem.ascii;
                    -----*/
                        Blklen = 128;
                        Ascii  = FALSE;
                        /* initialise les variables de rz */
                        DoXmodem = TRUE;
                        Batch = FALSE;
                        Nozmodem = FALSE;
                        Lzconv = Ascii ? ZCNL : ZCBIN;
                        Lzmanag = 0;

                             printf("Nom du fichier: ");
                             gets(Nom_Fichier);
                             if(!strlen(Nom_Fichier)) return;
                             nfiles = expand(Nom_Fichier);
                             if(nfiles) nfiles =1;
                        /* titre de la boite de transfert */
                        printf("- Envoi X-modem -\n");
                        break;
#endif
        }

        if( nfiles==0 )
        {
                ZmodemMsg("Aucun fichier Trouv !");
                beep(1);
                delay(1000);
                return;
        }

        if( nfiles==0xFF )
        {
                ZmodemMsg("Trop de fichiers correspondent!");
                beep(1);
                delay(1000);
                return;
        }


        /* initialise les variables globales */
        Rxtimeout = 600;
        Znulls = 0;/* peut etre introduire la possibilite de modifier le padding ? */

        Wcsmask=0377;
        Unlinkafter = 0;        /* Unlink file after it is sent */
        Dottoslash = 0;         /* Change foo.bar.baz to foo/bar/baz */
        errcnt = 0;             /* number of files unreadable */
        Filcnt = 0;             /* count of number of files opened */
        Lfseen = FALSE;
        Rxbuflen = 16384;       /* Receiver's max buffer length */
        Tframlen = 0;           /* Override for tx frame length */
        blkopt = 0;             /* Override value for zmodem blklen */
        Rxflags = 0;
        Zmodem = 0;             /* Zmodem protocol is requested */
        Lskipnocor = 0;
        Zctlesc  = 0;
        Usevhdrs = 0;           /* C'est le recepteur qui dira! */


        /* on installe notre petit break a nous */
        if( setjmp(abrtjmp) )
        {
                ZmodemMsg("  Abandon par l' utilisateur.");
                canit();                       /* stoppe moi tout ca toi */

                if( in )
                        fclose(in);         /* ferme le fichier d'entree */
                beep(1);
                do_send = FALSE;
                return;
        }

        /* Ici le !Nozmodem est peut etre inutile... */
        if ( !DoXmodem && !Nozmodem )
        {
                SendCommand(NumPort,"rz\r");
                stohdr(0L);
                if( Command )
                        Txhdr[ZF0] = ZCOMMAND;
                zshhdr(4,ZRQINIT, Txhdr);
        }




        if( Command )
        {
                if (getzrxinit())
                        canit();
                else if (zsendcmd(Cmdstr, 1+strlen(Cmdstr)))
                        canit();
        }

        else
               if (wcsend(nfiles)==ERROR)
                canit();

        beep(3);
        ZmodemMsg(" Transfert Termin");
}






/*
 * WCSEND: fonction principale d'envoi de fichiers
 * -----------------------------------------------
 */

wcsend(argc)
short argc;                     /* nombre de fichiers a transmettre */

{
        register n;
        char BufTxt[50];
        Crcflg = FALSE;
        Firstsec  = TRUE;
        bytcnt = -1;

        for (n=0; n<argc; ++n)
        {
                Totsecs = 0;
                Recover = 0;
                if( (argc - n) > 1)
                 mwrite(27,15,"A envoyer:      Fichiers",Jaune_vert);
                else
                mwrite(27,15,"A envoyer:      Fichier " ,Jaune_vert);
                sprintf(BufTxt,"%d ",argc - n);
                mwrite(39,15,BufTxt,Blanc_vert);

                ready_next();   /* indique qu'on est pret */
                 if (wcs(Liste_Files[n])==ERROR)
                        return ERROR;
        }

        Totsecs = 0;

        if (Filcnt==0)          /* bitch if we couldn't open ANY files */
        {
                /* aucun fichier: on envoie une commande... */
                Command = TRUE;
                Cmdstr = "echo \"SendZmodem: Can't open any requested files\"";
                if (getnak())
                        canit();
                if( !Zmodem )
                        canit();
                else if( zsendcmd(Cmdstr, 1+strlen(Cmdstr)) )
                        canit();
                return OK;
        }

        if( Zmodem )          /* Zmodem : goodbye stranger, plus de fichiers */
                saybibi();
        else if( !DoXmodem )  /* Ymodem : envoie un entete vide pour */
                wctxpn("");   /* indiquer la fin du transfert        */
        return OK;
}

/*
 * WCS: envoyer un fichier
 * -----------------------
 * Je prfre tout envoyer en MINUSCULES pour le nom.
 * Dtermine en foncion de l'extension zip ou arc etc... si le fichier est
 * deja compact, auquel cas on annule la compression a l'envoi.
 */
wcs(oname)
char *oname;
{
        struct stat f;
        char name[PATHLEN];

        strcpy(name, oname);
        stat (oname,&f);
        if ((in=fopen(oname, "rb"))==NULL)
        {
                ++errcnt;
                return OK;        /* pass over it, there may be others */
        }
        setvbuf(in,NULL,_IOFBF,10240);        /*Tente de bufferiser 10ko  */

        strlwr(name);             /* Passe en minuscules.  */
        if(Is_Compressed(name))
            Lztrans = FALSE;      /* Annule la compression */
        Eofseen = 0;              /* M'a fait chier celui la! */
       /*BEofseen = Eofseen = 0;
        vpos = 0;*/
        ++Noeofseen;
        Lastread = 0;
        Lastn = -1;
        Dontread = FALSE;

        Totsecs  = 0;
        bytcnt   = 0;
        Rxpos    = 0;
        Txpos    = 0;
        txbytes  = 0;


        ++Filcnt;

        switch (wctxpn(name))
        {
        case ERROR:
                return ERROR;
        case ZSKIP:
                return OK;
        }
        if (!Zmodem && wctx(f.st_size)==ERROR)
                return ERROR;

        if (Unlinkafter)
                unlink(oname);
        return 0;
}


/*
 * WCTXPN
 * generate and transmit pathname block consisting of
 * pathname (null terminated),
 * file length, mode time and file mode in octal
 * as provided by the Unix fstat call.
 * N.B.: modifies the passed name, may extend it!
 * --------------------------------------------------
 */
wctxpn(name)
char *name;
{
        register char *p, *q;
        char name2[PATHLEN];
        char BufTxt[50];
        struct stat f;
        short ret;
        unsigned long unixtime;


        /* recupere la structure stat avant qu'on ne modifie le nom */
        ret = stat(name, &f);

                filtre_filename(name2,name);
                total_oct = f.st_size ;
                time(&Time_Start);
                mwrite(36,10,"                    ",Blanc_vert); /* Efface*/
                mwrite(36,11,"         "           ,Blanc_vert); /* aussi.*/
                mwrite(36,10,name2,Blanc_vert);
                ltoa(total_oct,BufTxt,10);
                mwrite(36,11,BufTxt,Blanc_vert);
                mwrite(27,16,  "                             ",Cyan_vert);
                      /* Efface eventuel message de reprise */
                zmr_err();


        /* en Xmodem, on ne transmet pas le pathname */
        /* if( DoXmodem )                            */
        /*        return OK;                         */

                   /* petit message d'information    */
                   /* "awaiting pathname nak"        */

        ZmodemMsg(" Attente Acquittement...");

        if( !Zmodem )
                if (getnak())
                        return ERROR;



        /* convert to Unix style path names */
        /* skip any device identifier       */

                if( name[0]>='a' && name[0]<='p' && (name[1] == ':'))
                        name = &name[2];

                for(p = name; *p != '\0'; p++)
                {
                        if(*p == '\\')
                                *p = '/';
                }

                q = NULL;
                if (Dottoslash)                /* change . to / */
                {
                        for (p=name; *p; ++p)
                        {
                                if (*p == '/')
                                        q = p;
                                else if (*p == '.')
                                        *(q=p) = '/';
                        }

                        if (q && strlen(++q) > 8)       /* If name>8 chars */
                        {
                                q += 8;                 /* make it .ext */
                                strcpy(name2, q);       /* save excess of name */
                                *q = '.';
                                strcpy(++q, name2);     /* add it back */
                        }
                }

                for (p=name, q=txbuf ; *p; )
                        if ((*q++ = *p++) == '/' && !Fullname)
                                q = txbuf;
                *q++ = 0;
                p = q;
                while (q < (txbuf + KSIZE))
                        *q++ = 0;

        if( !Ascii && *name && ret!=-1 )
        {
                unixtime = f.st_mtime;
                sprintf(p, "%lu %lo %o", f.st_size,
                        unixtime, ((f.st_mode & 0x01)?0444:0644));
        }

        /* force 1k blocks if name won't fit in 128 byte block */

        if (txbuf[125])
                Blklen=KSIZE;
        else      /* A little goodie for IMP/KMD */
        {
                if (Zmodem)
                        Blklen = SECSIZ;
                txbuf[127] = (f.st_size + 127) >>7;
                txbuf[126] = (f.st_size + 127) >>15;
        }
        if (Zmodem)
                return zsendfile(txbuf, 1+strlen(p)+(p-txbuf));
        if( wcputsec(txbuf, 0, SECSIZ)==ERROR )
                return ERROR;
        return OK;
}


/*
 * GETNAK
 * ------
 */
getnak()
{
        register firstch;

        Lastrx = 0;
        for (;;)
        {
                firstch= readock(600,1);  /* 1 minute,ca suffit! */
                switch (firstch )
                {
                case ZPAD:
                        if (getzrxinit())
                                return ERROR;
                        Ascii = 0;
                        return FALSE;
                case TIMEOUT:
                                                   /* "timeout on pathname" */
                        ZmodemMsg("Time-Out sur Paquet d'init.");
                        return TRUE;
                case WANTG:
                        Optiong = TRUE;
                        Blklen=KSIZE;
                case WANTCRC:
                        Crcflg = TRUE;
                case NAK:
                        return FALSE;
                case CAN:
                        if ((firstch = readock(20,1)) == CAN && Lastrx == CAN)
                                return TRUE;
                default:
                        break;
                }
                Lastrx = firstch;
        }
}


/*
 * WCTX: transmet un fichier en X/Ymodem
 * -------------------------------------
 */
wctx(flen)
long flen;
{
        register int thisBlklen;
        register int sectnum, attempts, firstch;
        long charssent;

        charssent = 0;
        Firstsec=TRUE;
        thisBlklen = Blklen;

        while ((firstch=readock(Rxtimeout, 2))!=NAK && firstch != WANTCRC
          && firstch!=WANTG && firstch!=TIMEOUT && firstch!=CAN);

        if (firstch==CAN)
        {
                                    /* "Receiver CANcelled" */
                ZmodemMsg("Interrompu par l'autre ct");
                return ERROR;
        }

        if (firstch==WANTCRC)
                Crcflg=TRUE;
        if (firstch==WANTG)
                Crcflg=TRUE;
        sectnum=0;

        for (;;)
        {
                if (flen <= (charssent + 896L))
                        thisBlklen = 128;
                if ( !filbuf(txbuf, thisBlklen))
                        break;
                if (wcputsec(txbuf, ++sectnum, thisBlklen)==ERROR)
                        return ERROR;
                charssent += thisBlklen;
        }

        fclose(in);

        attempts=0;
        do
        {
                XFlush(NumPort);
                sendline(EOT);
                ++attempts;
        } while( (firstch=(readock(Rxtimeout,1) != ACK))!=0 && attempts < RETRYMAX);

        if (attempts == RETRYMAX)
        {
                /* "No Ack on EOT" */
                ZmodemMsg("Aucune rponse  l'EOT");
                return ERROR;
        }
        else
                return OK;
}


/*
 * WCPUTSEC: envoie un bloc de donnees
 * -----------------------------------
 */


wcputsec(buf, sectnum, cseclen)
char *buf;
int sectnum;
int cseclen;    /* data length of this sector to send */
{
        register checksum, wcj;
        register char *cp;
        unsigned oldcrc;
        int firstch;
        int attempts;

        firstch=0;                      /* part of logic to detect CAN CAN */

        for (attempts=0; attempts <= RETRYMAX; attempts++)
        {
                /* envoie la sequence de debut de paquet */
                Lastrx = firstch;
                sendline(cseclen==KSIZE ? STX : SOH);
                sendline(sectnum);
                sendline(-sectnum -1);
                oldcrc = checksum = 0;

                /* envoie le paquet de donnees */
                for (wcj=cseclen, cp=buf; --wcj>=0; )
                {
                        sendline(*cp);
                        oldcrc=updcrc((0377 & *cp), oldcrc);
                        checksum += *cp++;
                }

                /* envoie le CRC/Checksum */
                if (Crcflg)
                {
                        oldcrc = updcrc(0,updcrc(0,oldcrc));
                        sendline(oldcrc>>8);
                        sendline(oldcrc);
                }
                else
                        sendline(checksum);

                if (Optiong)
                {
                        Firstsec = FALSE;
                        return OK;
                }

                /* attend la reponse de joe, le cowboy solitaire a l'autre */
                /* bout de la rue <- F.P.    Poil au cul. <- R.C.          */
                firstch = readock(Rxtimeout, (Noeofseen&&sectnum) ? 2:1);
gotnak:
                switch (firstch)
                {
                case CAN:
                        if(Lastrx == CAN)
                        {
cancan:
                                        /* "Transmission interrompue" */
                                ZmodemMsg("Interrompu par le Rcepteur");
                                tot_errors++;
                                zmr_err();
                                return ERROR;
                        }
                        break;
                case TIMEOUT:
                                        /* "Timeout on sector ACK" */
                        ZmodemMsg("Time-out sur acquittement Bloc");
                        tot_errors++;
                        zmr_err();
                        continue;
                case WANTCRC:
                        if (Firstsec)
                                Crcflg = TRUE;
                case NAK:
                                /* "NAK on sector" */
                        ZmodemMsg("  NAK sur ce bloc l...");
                        tot_errors++;
                        zmr_err();
                        continue;
                case ACK:
                        Firstsec=FALSE;
                        Totsecs += (cseclen>>7);
                        txbytes += cseclen;
                        zmr_err();
                        return OK;
                case ERROR:
                                /* "Got burst for sector ACK" */
                        ZmodemMsg("Gros caca sur l'acquittement :-)");
                        tot_errors++;
                        zmr_err();
                        break;
                default:
                                /* "Got wrong for sector ACK" */
                        ZmodemMsg("Acquittement tout abm :-)");
                        tot_errors++;
                        zmr_err();
                        break;
                }

                for (;;)
                {
                        Lastrx = firstch;
                        if ((firstch = readock(Rxtimeout, 2)) == TIMEOUT)
                                break;
                        if (firstch == NAK || firstch == WANTCRC)
                                goto gotnak;
                        if (firstch == CAN && Lastrx == CAN)
                                goto cancan;
                }
        }
                        /* "Retry Count Exceeded" */
        ZmodemMsg("   TROP D'ERREURS");
        return ERROR;
}


/*
 * FILBUF: fill buf with count chars padding with ^Z for CPM
 * ---------------------------------------------------------
 */
filbuf(buf, count)
register char *buf;
short count;
{
        register c, m;

        if ( !Ascii)
        {
                m = fread(buf, 1, count, in);
                if (m <= 0)
                        return 0;
                while (m < count)
                        buf[m++] = 032;
                return count;
        }

        m=count;
        if (Lfseen)
        {
                *buf++ = 012;
                --m;
                Lfseen = 0;
        }

        while ((c=fgetc(in))!=EOF)
        {
                if (c == 012)
                {
                        *buf++ = 015;
                        if (--m == 0)
                        {
                                Lfseen = TRUE;
                                break;
                        }
                }
                *buf++ =c;
                if (--m == 0)
                        break;
        }

        if (m==count)
                return 0;
        else while (--m>=0)
                *buf++ = CPMEOF;
        return count;
}


/*
 * ZFILBUF: fill buf with count chars
 * ----------------------------------
 */
zfilbuf()
{
	int n;

#ifdef TXBSIZE
	/* We assume request is within buffer, or just beyond */
	txbuf = Txb + (bytcnt & TXBMASK);
	if (vpos <= bytcnt)
        {
		n = fread(txbuf, 1, blklen, in);

		vpos += n;
		if (n < blklen)
			Eofseen = 1;
		/* vfile("zfilbuf: n=%d vpos=%lu Eofseen=%d", n, vpos, Eofseen);*/
		return n;
	}
	if (vpos >= (bytcnt+blklen))
		return blklen;
	/* May be a short block if crash recovery etc. */
	Eofseen = BEofseen;
	return (vpos - bytcnt);
#else
	n = fread(txbuf, 1, blklen, in);
	if (n < blklen)
		Eofseen = 1;
	return n;
#endif
}




/*
 * readock(timeout, count) reads character(s) from file descriptor 0
 *  (1 <= count <= 3)
 * it attempts to read count characters. If it gets more than one,
 * it is an error unless all are CAN
 * (otherwise, only normal response is ACK, CAN, or C)
 *  Only looks for one if Optiong, which signifies cbreak, not raw input
 *
 * timeout is in tenths of seconds
 * ---------------------------------------------------------------------
 */
readock(timeout, count)
short timeout, count;
{
        register int c;
        register unsigned long temps;
        int ch;
        static char byt[5];
        long tic1;

        tic1 = get_ticks();
        if (Optiong)
                count = 1;      /* Special hack for cbreak */

        temps = 2  * (unsigned long) timeout;
        if( temps < 40  )               /* 2 secondes */
                temps = 40 ;

        c = 0;

        while( (get_ticks() - tic1) < (long) temps  && c < count )
        {
                /* des qu'on en a un en entree, on le prends et */
                /* on en prends autant que demande si ils y sont. */
                /* puis on sort. L'important est de voir que le fait */
                /* qu'il yaie au moins 1 caractere en attente fait */
                /* sortir de la boucle */
                /* if( io_state(RS232) ) */
                if(PortReady(NumPort))
                {
                        do
                        {
                                byt[c++] = Receive(NumPort);
                        }
                        while( c < count && PortReady(NumPort) );
                        break;
                }
                else            /* test du clavier pour abort */
                {

                 if( kbhit())
                   {
                    ch = getch();
                    if (ch == 24)  /* CONTROL-X arrte le Y modem */
                       {
                        longjmp(abrtjmp, 1);    /* aborted by user */
                       }
                   }

                }
        }

        if( c==0 )
                return TIMEOUT;
        if (c==1)
                return (byt[0]&0377);
        else while (c)
                if( byt[--c] != CAN )
                        return ERROR;
        return CAN;
}


/*
 * GETZRXINIT: Get the receiver's init parameters
 * ----------------------------------------------
 */
getzrxinit()          /* La, faudra voir le case ZRINIT... pas sur...! */
{
	register n;

	for (n=10; --n>=0; ) {

		switch (zgethdr(Rxhdr, 1))
                {
		case ZCHALLENGE:	/* Echo receiver's challenge numbr */
			stohdr(Rxpos);
			zshhdr(4, ZACK, Txhdr);
			continue;
		case ZCOMMAND:		/* They didn't see out ZRQINIT */
			stohdr(0L);
			zshhdr(4, ZRQINIT, Txhdr);
			continue;
		case ZRINIT:
			Rxflags = 0377 & Rxhdr[ZF0];
			Usevhdrs = Rxhdr[ZF1] & CANVHDR;
			Txfcs32 = (Wantfcs32 && (Rxflags & CANFC32));
			Zctlesc |= Rxflags & TESCCTL;
			Rxbuflen = (0377 & Rxhdr[ZP0])+((0377 & Rxhdr[ZP1])<<8);
			if ( !(Rxflags & CANFDX))
				Txwindow = 0;

#ifndef READCHECK
			/* Use 1024 byte frames if no sample/interrupt */
			if (Rxbuflen < 32 || Rxbuflen > 1024)
				 Rxbuflen = 4096;
                                /*  Rxbuflen = 0;*/ /* Sinon ca ralentit, */
                                                /* fait chier ca...   */
#endif

			/* Override to force shorter frame length */
			if (Rxbuflen && (Rxbuflen>Tframlen) && (Tframlen>=32))
				Rxbuflen = Tframlen;
			if ( !Rxbuflen && (Tframlen>=32) && (Tframlen<=1024))
				Rxbuflen = Tframlen;


			/* Set initial subpacket length */
			if (blklen < 1024)
                        {	/* Command line override? */
				if (BaudRate > 300)
					blklen = 256;
                if (BaudRate >= 1200)
					blklen = 512;
                if (BaudRate >= 2400)
					blklen = 1024;
			}
			if (Rxbuflen && blklen>Rxbuflen)
				blklen = Rxbuflen;
			if (blkopt && blklen > blkopt)
				blklen = blkopt;


			if (Lztrans == ZTRLE && (Rxflags & CANRLE))
				Txfcs32 = 2;
			else
				Lztrans = 0;

			return (sendzsinit());
		case ZCAN:
		case TIMEOUT:
			return ERROR;
		case ZRQINIT:
			if (Rxhdr[ZF0] == ZCOMMAND)
				continue;
		default:
			zshhdr(4, ZNAK, Txhdr);
			continue;
		}
	}
	return ERROR;
}


/*
 * SENDZSINIT: Send send-init information
 * --------------------------------------
 */
sendzsinit()
{
	register c;

	if (Myattn[0] == '\0' && (!Zctlesc || (Rxflags & TESCCTL)))
		return OK;
	errors = 0;
	for (;;) {
		stohdr(0L);
		if (Zctlesc)
                {
			Txhdr[ZF0] |= TESCCTL;
                        zshhdr(4, ZSINIT, Txhdr);
		}
		else
			zsbhdr(4, ZSINIT, Txhdr);
		zsdata(Myattn, ZATTNLEN, ZCRCW);
		c = zgethdr(Rxhdr, 1);
		switch (c)
                {
		case ZCAN:
			return ERROR;
		case ZACK:
			return OK;
		default:
			if (++errors > 19)
				return ERROR;
			continue;
		}
	}
}



/*
 * ZSENDFILE
 * Send file name and related info
 * -------------------------------
 */
zsendfile(buf, blen)
char *buf;
short blen;
{
	register c;
	unsigned long crc;
	long lastcrcrq = -1;
        char BufTxt[50]; /* Pour les sprintf */

	for (;;)
        {
		Txhdr[ZF0] = Lzconv;	/* file conversion request */
		Txhdr[ZF1] = Lzmanag;	/* file management request */
		if (Lskipnocor)
			Txhdr[ZF1] |= ZMSKNOLOC;
		Txhdr[ZF2] = Lztrans;	/* file transport request */
		Txhdr[ZF3] = 0;
		zsbhdr(4, ZFILE, Txhdr);
		zsdata(buf, blen, ZCRCW);
again:
		c = zgethdr(Rxhdr, 1);
		switch (c)
                {
		case ZRINIT:
			while ((c = readline(50)) > 0)
				if (c == ZPAD)
                                {
					goto again;
				}
			continue;
		case ZCAN:
		case TIMEOUT:
		case ZABORT:
		case ZFIN:
		default:
			return ERROR;
		case ZCRC:
			if (Rxpos != lastcrcrq)
                        {
				lastcrcrq = Rxpos;
				crc = 0xFFFFFFFFL;
                  		fseek(in, 0L, 0);
				while (((c = getc(in)) != EOF) && --lastcrcrq)
					crc = UPDC32(c, crc);
				crc = ~crc;
				clearerr(in);	/* Clear possible EOF */
				lastcrcrq = Rxpos;
			}
			stohdr(crc);
			zsbhdr(4, ZCRC, Txhdr);
			goto again;
		case ZFERR:
		case ZSKIP:
			fclose(in);
                        return c;
		case ZRPOS:
			/*
			 * Suppress zcrcw request otherwise triggered by
			 * lastyunc==bytcnt
			 */
                        ZmodemMsg("  Envoi en cours...");
                        Lastsync = (bytcnt = Txpos = Rxpos) -1;
			if (fseek(in, Rxpos, 0))
				  return ERROR;
			Lastsync = (bytcnt = Txpos = Lrxpos = Rxpos) -1;
                        if(Rxpos != 0L)  /* Affiche Crash Recovery */
                          {
                           Recover = Rxpos;
                           sprintf(BufTxt,"Reprise  %ld Octets",Rxpos);
                           mwrite(27,16,BufTxt,Cyan_vert);
                          }
                        Dontread = FALSE;   /* Y tait pas..??? */
			return zsendfdata();
		}
	}
}


/*
 * ZSENDFDATA: Send the data in the file
 * -------------------------------------
 */

zsendfdata()
{
	register c, e, n;
	register newcnt;
	long tcount = 0;
	int junkcount;		/* Counts garbage chars received by TX */
        char BufTxt[60];        /* Pour les sprintf      */
        unsigned char ch;

	junkcount = 0;
	Beenhereb4 = FALSE;

                                 /*----- Affichage type transmission ---*/
                 switch(Crc32t)
                       {
                        case 0:
                         sprintf(BufTxt,"CRC-16");
                        break;
                        case 1:
                         sprintf(BufTxt,"CRC-32");
                        break;
                        case 2:
                         sprintf(BufTxt,"CRC-32+RLE");
                        break;
                       }
                       mwrite(40,21,BufTxt,Cyan_vert);
                 if(Usevhdrs)
                       mwrite(35,21,"VHDR+",Cyan_vert);
                                  /*-----------------------------------*/


	if (0)                  /* On n'a pas besoin du setjmp ici.    */
        {
waitack:
		junkcount = 0;
		c = getinsync(0);
gotack:
		switch (c)
                {
		default:
		case ZCAN:
			fclose(in);
			return ERROR;
		case ZSKIP:
			fclose(in);
			return c;
		case ZACK:
		case ZRPOS:
			break;
		case ZRINIT:
			return OK;
		}
        }




somemore :       /* Label deplace du if(0) ici plutot... */


#ifdef READCHECK
		/*
		 * If the reverse channel can be tested for data,
		 *  this logic may be used to detect error packets
		 *  sent by the receiver, in place of setjmp/longjmp
		 *  rdchk(fd) returns non 0 if a character is available
		 */
		while (rdchk(0))
                {
			switch (readline(1))
			{
			case CAN:
			case ZPAD:
				c = getinsync(1);
				goto gotack;
			case XOFF:		/* Wait a while for an XON */
			case XOFF|0200:
				readline(100);
			}
		}
#endif



	newcnt = Rxbuflen;
	Txwcnt = 0;
	stohdr(Txpos);
	zsbhdr(4, ZDATA, Txhdr);

	do
        {

                        /*-------bloc rajout par moi  , y tait pas----*/
          if( kbhit())
          {
            if ( getch() == 24)  /* CONTROL-X arrte le Z modem */
               {
                 longjmp(abrtjmp, 1);    /* aborted by user */
               }
          }

                /*----------------------------------------------*/

                /*-------bloc pomp sur Florent, y tait pas----*/
                if (Dontread)
                        n = Lastn;
                else
                {
                        n = zfilbuf();
                        Lastread = Txpos;
                        Lastn = n;
                }
                Dontread = FALSE;
                /*----------------------------------------------*/
		/* n = zfilbuf();*/
		if (Eofseen)
			e = ZCRCE;
		else if (junkcount > 3)
			e = ZCRCW;
		else if (bytcnt == Lastsync)
			e = ZCRCW;
		else if (Rxbuflen && (newcnt -= n) <= 0)
			e = ZCRCW;
		else if (Txwindow && (Txwcnt += n) >= Txwspac)
                {
			Txwcnt = 0;  e = ZCRCQ;
		} else
			e = ZCRCG;


		zsdata(txbuf, n, e);
		bytcnt = Txpos += n;

                                 /*---- Affichage statistiques  --------*/
                 zmr_err();
                 sprintf(BufTxt,"%ld  ",total_oct - bytcnt);
                 mwrite(36,12,"        ",Blanc_vert);
                 mwrite(36,12,BufTxt,Blanc_vert); /* Corrige l'erreur */

                                /*-------------------------------------*/
		if (e == ZCRCW)
			goto waitack;



#ifdef READCHECK
		/*
		 * If the reverse channel can be tested for data,
		 *  this logic may be used to detect error packets
		 *  sent by the receiver, in place of setjmp/longjmp
		 *  rdchk(fd) returns non 0 if a character is available
		 */
		/*fflush(stdout);*/
		while (rdchk(0))
                {
			switch (readline(1))
			{
			case CAN:
			case ZPAD:
				c = getinsync(1);
				if (c == ZACK)
					break;
				/* zcrce - dinna wanna starta ping-pong game */
				zsdata(txbuf, 0, ZCRCE);
				goto gotack;
			case XOFF:		/* Wait a while for an XON */
			case XOFF|0200:
				readline(100);
			default:
				++junkcount;
			}
		}
#endif  /* READCHECK */




		if (Txwindow)
                {
			while ((tcount = (Txpos - Lrxpos)) >= Txwindow)
                        {
				/* vfile("%ld window >= %u", tcount, Txwindow);*/
				if (e != ZCRCQ)
					zsdata(txbuf, 0, e = ZCRCQ);
				c = getinsync(1);
				if (c != ZACK)
                                {
					zsdata(txbuf, 0, ZCRCE);
					goto gotack;
				}
			}
			/* vfile("window = %ld", tcount); */
		}

#ifdef RAJOUT
                /*-------- Rajout pour que ca marche... ?????? *----------*/
                if(PortReady(NumPort) ) /* Il se passe un truc*/
                  {
                     ch = Receive(NumPort);
                     if( ch !=17) /* Je pige pas ce que c'est!!!!!!!*/
                       {
                        UnReceive(NumPort,ch);
                        goto waitack;
                       }
                  }
                /*-------------------------------------------------------*/
#endif

	} while (!Eofseen);

	for (;;)        /* Fin de transfert */
        {

		stohdr(Txpos);
		zsbhdr(4, ZEOF, Txhdr);
		switch (getinsync(0))
                {
		case ZACK:
			continue;
		case ZRPOS:
			goto somemore;
		case ZRINIT:
			return OK;
		case ZSKIP:
			fclose(in);
			return c;
		default:
			fclose(in);
			return ERROR;
		}
	}
}



/*
 * Respond to receiver's complaint, get back in sync with receiver
 * ---------------------------------------------------------------
 */

getinsync(flag)
{
	register c;

	for (;;)
        {
		c = zgethdr(Rxhdr, 0);
		switch (c)
                {
		case ZCAN:
		case ZABORT:
		case ZFIN:
		case TIMEOUT:
                        tot_errors++;
                        zmr_err();
			return ERROR;
		case ZRPOS:
			/* ************************************* */
			/*  If sending to a buffered modem, you  */
			/*   might send a break at this point to */
			/*   dump the modem's buffer.		 */
			/*clearerr(in);*/	/* In case file EOF seen */
                        /* Bloc test y tait pas, rajout */
                        if (Lastn >= 0 && Lastread == Rxpos)
                                Dontread = TRUE;
                        else
                        {
                                clearerr(in);   /* In case file EOF seen */
                             if(   fseek(in, Rxpos, 0))
                                return(ERROR);
                        }
			Eofseen = 0;
			bytcnt = Lrxpos = Txpos = Rxpos;
			Lastsync = Rxpos;
			return c;
		case ZACK:
			Lrxpos = Rxpos;
			if (flag || Txpos == Rxpos)
				return ZACK;
                        zmr_err();
			continue;
		case ZRINIT:
		case ZSKIP:
			fclose(in);
			return c;
		case ERROR:
		default:
                        tot_errors++;
                        zmr_err();
			zsbhdr(4, ZNAK, Txhdr);
			continue;
		}
	}
}



/*
 * SAYBIBI: Say "bibi" to the receiver, try to do it cleanly
 * ---------------------------------------------------------
 */

saybibi()
{
	for (;;)
        {
		stohdr(0L);		/* CAF Was zsbhdr - minor change */
		zshhdr(4, ZFIN, Txhdr);	/*  to make debugging easier */
		switch (zgethdr(Rxhdr, 0))
                {
         		case ZFIN:
	        	  	sendline('O');
                                sendline('O');
     		        case ZCAN:
          		case TIMEOUT:
			return;
		}
	}
}



/*
 * Send command and related info
 * -----------------------------
 */

zsendcmd(buf, blen)
char *buf;
{
	register c;
	long cmdnum;

	/* cmdnum = getpid();  Mais oui, sous DOS mon bon monsieur :-) */
        cmdnum    = 1;
	errors = 0;
	for (;;)
        {
		stohdr(cmdnum);
		Txhdr[ZF0] = Cmdack1;
		zsbhdr(4, ZCOMMAND, Txhdr);
		zsdata(buf, blen, ZCRCW);
listen:
		Rxtimeout = 100;	/* Ten second wait for resp. */
		Usevhdrs = 0;		/* Allow rx to send fixed len headers */
		c = zgethdr(Rxhdr, 1);

		switch (c) {
		case ZRINIT:
			goto listen;	/* CAF 8-21-87 */
		case ERROR:
		case GCOUNT:
		case TIMEOUT:
			if (++errors > Cmdtries)
				return ERROR;
			continue;
		case ZCAN:
		case ZABORT:
		case ZFIN:
		case ZSKIP:
		case ZRPOS:
			return ERROR;
		default:
			if (++errors > 20)
				return ERROR;
			continue;
		case ZCOMPL:
			saybibi();
			return OK;
		case ZRQINIT:
			ZmodemMsg("Commande Non Supporte ici.");
			/* system("rz"); */
			goto listen;
		}
	}
}



/* End of sz.c */

