


/*
  ͻ
                                                                         
             DOMAINE      IBM-PC   MS-DOS(3.x+)      
                            PUBLIC                                 
                 Ren   Le protocole de Transfert BBT  
                          Cougnenc est de Jean-Claude Michot.     
                1989   La librairie de Comm. est de   
                                          J.P. Parisy & R.A. Gillmann    
  Ķ
                                                                          
                           PROGRAMME PERSO.C                              
                           -----------------                              
                                                                          
      Personnalisation de Bbth.exe pour les abonns QBBS.                 
      Lit la structure de config, et rajoute le nom du gars cod.         
                                                                          
      Le nom peut faire jusqu'a 22 caractres et comporter tous les       
      codes ascii,espaces compris.                                        
                                                                          
      Le flag Abonnement sera pris en compte si le premier char du        
      champ Config.AboName n'est pas le caractre 0.                      
                                                                          
      Pour mettre autre chose que "abonne a qbbs" entrer apres le nom     
      du programme un  nombre entre 1 et je ne sais plus, voir l'aide.    
                                                                          
  Ķ
                                                                          
   Ce programme est personnel et n'est pas en domaine public du tout.     
                                                                          
   Seuls les potes ayant eu acces aux sources de bbth doivent normalement 
   le possder.                                                           
   Et ceux grant les abonns et tout le tremblement bien entendu  !      
  ͼ
  Ŀ
  BbtH 1.20 
  
*/
/*--------------------------------------------------------*/
#ifndef __TURBOC__   /* Borland Turbo-c 1.5               */
#ifndef MSDOS        /* Microsoft C                       */
#error Mfiance ! je ne connais pas ce compilateur l...
#endif
#endif
/*--------------------------------------------------------*/

#define VERSION    "1.2"     /*<<<<< Pour CETTE version de Bbth !!! */

#include "bbth.h"
#include "config.h"

#include <stdio.h>
#ifdef __TURBOC__
#include <mem.h>
#include <conio.h>
#define printf cprintf
#define puts cputs
#else
#include <memory.h>
#include <sys/types.h>
#define SEEK_SET 0L
#define SEEK_END 2
#endif

#include <string.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <io.h>



struct ConfigType Config;

int  WriteConf(char *);
int  ReadConf (char *);
void brouille (byte *);
void aide     (void  );

#define MAXTYPE 5
static byte *QualifTypes[11]=
                           {
                            "   Abonn  QBBS    ",
                            " Auteur de  ce Soft ",
                            " Equipe Tech.  QBBS ",
                            " Gestionnaire  QBBS ",
                            " Le Sysop  de  QBBS ",
                            "   Joyeux  Drille   ",
                            "       Gnie.       ",
                            "     Gai - Luron    ",
                            " Mon vieux Copain ! ",
                            " Cadeau de l'Auteur ",
                            "Cadeau du serveur  FOX",
                           };

/*---------------------------------------------------------------------------*/

main(int argc,char **argv)
{
static byte Nom[80]="";
static byte Qualif[80]="" ;
byte cmd[63];
 int i=3;

#ifdef __TURBOC__
directvideo = 1;
#endif
 if( argc <2)
   {
    aide();
    return(1);
   }

 if(argc >2)              /* y'a le nom du mec, on le recupere */
   {
    if( (argv[2][0] > '0') && (argv[2][0] <= '9') )
      {
       strcpy(Qualif,QualifTypes[ atoi(argv[2]) ]);
       i++;
      }
      else strcpy(Qualif,QualifTypes[0]);  /* Abonn par dfaut */

    strcpy(Nom,argv[i-1]);
    while(argv[i]!=NULL)
         {
          strcat(Nom," ");
          strcat(Nom,argv[i]);
          i++;
         }
   }

 if( strlen(Nom) > 22)
   {
    printf("Le nom est trop long. 22 caractres tout compris au maximum.\n");
    printf("Celui  ci  en  compte %d .\n\n",strlen(Nom));
    return(4);
   }

 if (argc == 2) /* ON depersonnalise, dans ce cas pour rire je brouile */
    {           /* Les pistes en mettant n'importe quoi :-)            */
     strcpy(Nom,   " Non enregistr le mec");
     strcpy(Qualif,"Faut pas dconner quoi");
    }

 if( ! ReadConf(argv[1]) )           /* Lecture de la config courante     */
   {
    printf("Abruti ! Connard ! Andouille ! Rflchis un peu !\n");
    printf("Je ne vois pas de fichier '%s' ,moi !!!\n\n",argv[1]);
    return(2);
   }

 if(Config.StruVersion != STRUVER)
   {
     printf("Holalala !!!\n");
     printf("Numro de version incorrecte ! La config a chang !\n");
     printf("En bref c'est pas le bon programme 'perso',quoi...\n");
     return(4);
   }

 brouille(Nom);                      /* Codage et mise en place du nom     */
 strcpy( Config.AboName,Nom);
 brouille(Nom);

 brouille(Qualif);
 strcpy(Config.AboType,Qualif);
 brouille(Qualif);

if( argc == 2) Config.AboName[0] = 0;  /* hehe. */

 Config.CrcTest = calcrc(&Config.AboName[0],82 );

 if( ! WriteConf(argv[1]) )          /* Et ecriture de la nouvelle config. */
   {
    printf("J'ai t incapable d'ecrire dans le fichier %s.",argv[1]);
    return(3);
   }

if( argc == 2)
    printf("OK,le programme %s n'est plus  personnalis.\n",argv[1]);
  else
  {
    printf("OK,le programme %s est personnalis.\n",argv[1]);
    printf("Au  nom  de : %s\n",Nom);
    printf("En tant que : %s\n\n",Qualif);
    /* sprintf(cmd,"Abodoc %s >Abonne.Doc",Nom);
       system(cmd); */
  }
 return(0);
}

/*--------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
/*
     Ecriture de la config dans le programme.
*/

int WriteConf(char *programme)
   {
   int fichier;                               /* handle fichier             */
   int test;
   long Program_Taille;

   #ifdef __TURBOC__
   struct ftime datefich;
   #else
   unsigned DateFich,
            TimeFich;
   #endif


   fichier=open(programme,O_RDWR|O_BINARY,S_IREAD|S_IWRITE);
   if(fichier==-1)return(0);               /* mais c'est peu probable...*/

   #ifdef __TURBOC__
   getftime(fichier,&datefich);            /* conserve la date du fichier ! */
   #else
   _dos_getftime(fichier,&DateFich,&TimeFich);
   #endif


   Program_Taille=filelength(fichier);           /* prend la taille */
                                            /* Je vais au bon endroit...    */


   test=lseek(fichier,Program_Taille - (long)sizeof(Config),SEEK_SET);
   if(test==-1)
     {
      printf(" Erreur dans Seek.\n");
      exit(3);
     }

   write(fichier,(char *)&Config.RepereZone[0],sizeof(Config));
                                             /* Je patche le programme...    */
   #ifdef __TURBOC__
   setftime(fichier,&datefich);              /* Et je remets la bonne date,  */
   #else
   _dos_setftime(fichier,DateFich,TimeFich);
   #endif
   close(fichier);                           /* ma bonne dame !              */
   return(1);
  }
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*
         Lecture de la config existante
*/
int ReadConf(char *programme)
   {
   int fichier;                               /* handle fichier             */
   int test;
   long Program_Taille;



   fichier=open(programme,O_RDWR|O_BINARY,S_IREAD|S_IWRITE);
   if(fichier==-1)return(0);               /* mais c'est peu probable...*/



   Program_Taille=filelength(fichier);           /* prend la taille */


   test=lseek(fichier,Program_Taille - (long)sizeof(Config),SEEK_SET);
   if(test==-1)
     {
      printf(" Erreur dans Seek.\n");
      exit(3);
     }

   read(fichier,(char *)&Config.RepereZone[0],sizeof(Config));
   close(fichier);                           /* ma bonne dame !              */
   return(1);
  }
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
void aide(void)
{
int i;
printf("\n\n\n\n");
printf(" PERSONNALISATION de BBTH %s pour les ABONNES QBBS. [ R.Cougnenc 90 ] \n\n",VERSION);
puts("        Syntaxe:perso [chemin]bbth.exe nom de l'utilisateur\n\n"
     "        Place le nom de l'utilisateur cod dans le programme BbtH.\n"
     "        Maximum 22 caractres pour le nom,qui peut comporter des espaces.\n"
     "        ( Exemple: perso a:bbth.exe Ducon la Joie )\n"
     "        Le flag Abonn est alors mis a 1.\n\n"
     "        Pour dpersonnaliser le programme il suffit de ne pas entrer\n"
     "        de nom d'utilisateur.\n\n"
     "        Attention ! Si le fichier n'est pas BbtH.exe, il sera irrmdiablement\n"
     "        vrol jusqu' l'os !\n\n");

printf("Types D'utilisateurs:    [ Mmo pour Ren :-) ]\n\n");
for(i=0;i< MAXTYPE;i++)
printf("        - %d)  %s\n",i,QualifTypes[i]);

}
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*
     Fonction symetrique. Ca permet d'utiliser la meme et ca rend
     le truc assez illisible tout de meme.
*/
void brouille(byte *chaine)
{
 byte *ptr = chaine;

 while(*ptr)
      {
       *ptr= 0xFF - *ptr;
       ptr++;
      }
}
/*---------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------*/
/*

      Calcul du crc:extrait de la documentation de Chuck Forsberg

         Figure 8.  Example of CRC Calculation written in C


    This function calculates the CRC used by the XMODEM/CRC Protocol
    The first argument is a pointer to the message block.
    The second argument is the number of bytes in the message block.
    The function returns an integer which contains the CRC.
    The low order 16 bits are the coefficients of the CRC.
*/

   int calcrc(char *ptr, int count)
   {
       int crc, i;

       crc = 0;
       while(--count >= 0)
           {
           crc = crc ^ (int)*ptr++ << 8;
           for(i = 0; i < 8; ++i)
               if(crc & 0x8000)
                   crc = crc << 1 ^ 0x1021;
               else
                   crc = crc << 1;
           }
       return (crc & 0xFFFF);
   }

/*--------------------------------------------------------------------------*/

