


/*
  ͻ
                                                                         
             DOMAINE      IBM-PC   MS-DOS(3.x+)      
                            PUBLIC                                 
                 Ren   Le protocole de Transfert BBT  
                          Cougnenc est de Jean-Claude Michot.     
                1989   La librairie de Comm. est de   
                                          J.P. Parisy & R.A. Gillmann    
  Ķ
                                                                          
                    MODULE: REINST .C                                     
                    ----------------                                      
                                                                          
      Ecrit la structure de configuration avec les initialisations        
      persos dans le fichier     BBTH.EXE .                               
                                                                          
      Valeurs a mettre dans ce programme source.                          
                                                                          
      Ce programme est bien sur a modifier a chaque changement de la      
      structure de configuration !                                        
      ATTENTION DONC AU NUMERO DE VERSION, BON SANG DE BONSOIR !          
  Ķ
                                                                          
   Ce programme est personnel et n'est pas en domaine public du tout.     
                                                                          
   Seuls les potes ayant eu acces aux sources de bbth doivent normalement 
   le posseder.                                                           
   De toutes facons ils auraient tous pu se l'ecrire en vitesse... !      
  ͼ
  Ŀ
  BbtH 1.19
  
*/
/*--------------------------------------------------------*/
#ifndef __TURBOC__   /* Borland Turbo-c 1.5               */
#ifndef MSDOS        /* Microsoft C                       */
#error Mfiance ! je ne connais pas ce compilateur l...
#endif
#endif
/*--------------------------------------------------------*/

#define VERSION 1.2     /*<<<< Pour CETTE version de BbtH */

#include "bbth.h"
#include "config.h"

#ifdef __TURBOC__
#include <mem.h>
#include <conio.h>
#define printf cprintf
#define puts   cputs
#else
#include <memory.h>
#include <sys/types.h>
#define SEEK_SET 0L
#define SEEK_END 2
#endif

#include <string.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <io.h>

#ifdef BBTH           /* Pour Alphacom  c'est apres... */

struct ConfigType    /* INITIALISATION DES PRINCIPAUX CHAMPS DE LA STRUCTURE */
Config=
   {
   "(c)Ren Cougnenc [ France ] 1989",
   0L,         /* Offset 0 voir Write_Config*/
   0L,         /* Date de compilation */
   STRUVER,    /* version struct pour perso*/
   0,          /*test Crc calcule apres*/
   4,          /* Numero du Port       */
   2400,       /* Vitesse              */
   0,          /* Parite Paire         */
   8,          /* Nombre de bits       */
   1,          /* Bits d'arrt         */
   1,          /* Numero du terminal   */
   1,          /* Type de modem        */
   "",         /* Download Directory   */
   "",         /* Upload   Directory   */
   "ATZ^M",    /* Initialisation Modem */
   "ATDT",     /* Dialing Prefix       */
   "~~~+++~~~ATH0^M", /* HangUp string */
   "ATB3^M",   /* Passage en V23 normal*/
   "ATB2^M",   /* Passage V23 Inverse  */
   "ATB0^M",   /* Mode Normal du Modem */
   25,         /* Nb lignes ecran      */
   1,          /* Video EGA (2=VGA ,0  */
   "C^M",      /* Ident Qbbs:vtcolor   */
   "> ",       /* Quote du bloc txt souris   */
   "", /* Nom de l'abonn QBBS (000) */
   "", /* Qualification du mec (000) */
   1 ,         /* Affichage en couleurs      */
   1 ,         /* Musique ansi               */
   1 ,         /* Musique au debut et fin .  */
   1 ,         /* Zioup sur les fenetres .   */
   1 ,         /* Pages minitel...           */
   1 ,         /* Reprise Bbt ?              */
   1 ,         /* Reprise Zmodem ?           */
   1 ,         /* Beepe la cloche, pas Flash */
   2000,       /* 2 sec attente tone minitel */
   800 ,       /* Inter chiffre minitel      */
   33  ,       /* Pulse numero minitel       */
   66  ,       /* Inter pulse numero minitel */

  /*--------------------- Les ports de comm --------*/

   0x3F8,      /* adresse Com 1        */
   4,          /* Ligne IRQ pour COM1  */
   0x2F8,      /* adresse Com 2        */
   3,          /* Ligne IRQ pour COM2  */
   0x3E8,      /* adresse Com 3        */
   4,          /* Ligne IRQ pour COM3  */
   0x2E8,      /* adresse Com 4        */
   3,          /* Ligne IRQ pour COM4  */


   /*--------------------- Les 10 Macros Clavier----*/

   "195150485*BBS^SA",
   "195150632*TEASER^SA",
   "Cher ami,",
   "Monsieur le Directeur,",
   "Mon amour,",
   "Pauvre Imbcile,",
   "Veuillez croire  l'expression de ma sincre considration^M",
   "Allez salut,et bonne bourre !^M",
   "Tu payes ta tourne?^M",
   "+-----------+^M| BONJOUR ! |^M+-----------+^M",

   /*-------------------- Les 16 lignes d'annuaire--*/

   "TLTEL 2"     ,"3614"          ,"",1200,2,7,1,1,2,
   "TLTEL 1"     ,"3613"          ,"",1200,2,7,1,1,2,
   "Annuaire PTT"  ,"11"            ,"",1200,2,7,1,1,2,
   "MODULA"        ,"40 43 01 24"   ,"",2400,0,8,1,0,1,
   "MODULA"        ,"45 30 12 48"   ,"",2400,0,8,1,0,1,
   "SUPTEL-PRO"    ,"48 99 12 00"   ,"",2400,0,8,1,0,1,
   "SUPTEL-PRO"    ,"48 99 43 00"   ,"",2400,0,8,1,0,1,
   "KSM+"          ,"48 21 29 26"   ,"",2400,0,8,1,0,1,
   "Fox"           ,"42 53 53 62"   ,"",1200,2,7,1,1,2,
   "QBBS RTC"      ,"45 34 33 77"   ,"",1200,2,7,1,1,2,
   "QBBS 2400"     ,"46 23 01 54"   ,"",2400,0,8,1,0,1,
   "QBBS 2400"     ,"46 23 01 55"   ,"",2400,0,8,1,0,1,
   "LINN"          ,"46 55 37 91"   ,"",2400,0,8,1,0,1,
   "SOS-MICRO"     ,"46 21 32 70"   ,"",1200,0,8,1,0,1,
   "OUFLOG"        ,"47 83 33 83"   ,"", 300,0,8,1,0,0,
   "LI LL BBS"     ,"40 82 90 96"   ,"",2400,0,8,1,0,1,



  /*-------------------- Les Commandes Souris    --*/
  "APPEL   "   ,   "",
  "RACCROCH"   ,   "",
  "FIN     "   ,   "",
  "LOG     "   ,   "",
  "CLS     "   ,   "",
  "AIDE    "   ,   "",
  "BACK    "   ,   "",
  "ECRAN   "   ,   "",

  "TTY     "   ,   "",
  "ANSI    "   ,   "",
  "QNX     "   ,   "",
  "MINITEL "   ,   "",
  "HEURE   "   ,   "",
  "SYSTEME "   ,   "",
  "Bloc txt"   ,   "",
  "reconfig"   ,   "",

  "News    "   ,   "*con NEWS^M"        ,
  "Mail    "   ,   "*mail^M"            ,
  "LEADER  "   ,   "*con Leader^M"      ,
  "LEADER4 "   ,   "*con Leader4^M"     ,
  "DOWNLOAD"   ,   "*con Download^M"    ,
  "POLEMIK "   ,   "*con Polemiques^M"  ,
  "BBS     "   ,   "*con BBS^M"         ,
  "LE C    "   ,   "*con Le_C^M"        ,

  "Equipe  "   ,   "mail jcmichot Balkan Schauer Top LCI richard^M",
  "Who"   ,   "who^M",
  "*who "   ,   "*who^M",
  "Lchat"   ,   "*lchat^M",
  ""   ,   "",
  ""   ,   "",
  ""   ,   "",
  ""   ,   "",
   };


/*------------------- FIN D'INIT DE LA STRUCTURE --(pour bbth )-------------*/

#else
struct ConfigType    /* INITIALISATION DES PRINCIPAUX CHAMPS DE LA STRUCTURE */
Config=
   {
   "(c)Ren Cougnenc [ France ] 1989",
   0L,         /* Date de compilation */
   0L,         /* Offset 0 voir Write_Config*/
   STRUVER,    /* version struct pour perso*/
   0,          /*test Crc calcule apres*/
   1,          /* Numro du Port       */
   1200,       /* Vitesse              */
   2,          /* Parite Paire         */
   7,          /* Nombre de bits       */
   1,          /* Bits d'arrt         */
   1,          /* Numero du terminal   */
   1,          /* Type de modem        */
   "",         /* Download Directory   */
   "",         /* Upload   Directory   */
   "ATZ^M",    /* Initialisation Modem */
   "ATDT",     /* Dialing Prefix       */
   "~~~+++~~~ATH0^M", /* HangUp string */
   "",         /* Passage en V23 normal*/
   "",         /* Passage V23 Inverse  */
   "ATB0^M",   /* Mode Normal du Modem */
   25,         /* Nb lignes ecran      */
   0,          /* Video EGA (2=VGA ,0  */
   "C^M",      /* Ident Qbbs:vtcolor   */
   "> ",       /* Quote du bloc txt souris   */
   "", /* Nom de l'abonn QBBS (000) */
   "", /* Qualification du mec (000) */
   1 ,         /* Affichage en couleurs      */
   1 ,         /* Musique ansi               */
   1 ,         /* Musique au debut et fin .  */
   1 ,         /* Zioup sur les fenetres .   */
   1 ,         /* Pages minitel...           */
   1 ,         /* Reprise Bbt ?              */
   1 ,         /* Reprise Zmodem ?           */
   0 ,         /* Beepe la cloche, pas Flash */
   2000,       /* 2 sec attente tone minitel */
   800 ,       /* Inter chiffre minitel      */
   33  ,       /* Pulse numero minitel       */
   66  ,       /* Inter pulse numero minitel */

  /*--------------------- Les ports de comm --------*/

   0x3F8,      /* adresse Com 1        */
   4,          /* Ligne IRQ pour COM1  */
   0x2F8,      /* adresse Com 2        */
   3,          /* Ligne IRQ pour COM2  */
   0x3E8,      /* adresse Com 3        */
   4,          /* Ligne IRQ pour COM3  */
   0x2E8,      /* adresse Com 4        */
   3,          /* Ligne IRQ pour COM4  */


   /*--------------------- Les 10 Macros Clavier----*/

   "mon_login^Mmon_passe^M",
   "TEASER^SA",
   "Cher ami,",
   "",
   "",
   "",
   "",
   "",
   "",
   "+-----------+^M| BONJOUR ! |^M+-----------+^M",

   /*-------------------- Les 16 lignes d'annuaire--*/
   "Annuaire PTT"  ,"11"            ,"",1200,2,7,1,1,2,
   "TLTEL 1"     ,"3613"          ,"",1200,2,7,1,1,2,
   "TLTEL 2"     ,"3614"          ,"",1200,2,7,1,1,2,
   "TLTEL 3"     ,"3615"          ,"",1200,2,7,1,1,2,
   "Teaser"        ,"45 34 03 00"   ,"",1200,2,7,1,1,2,
   "Fox"           ,"42 53 53 62"   ,"",1200,2,7,1,1,2,
   "SUPTEL-PRO"    ,"48 99 43 00"   ,"",1200,0,8,1,0,1,
   "QBBS v23"      ,"45 34 33 77"   ,"",1200,2,7,1,1,1,
   "MODULA"        ,"40 43 01 24"   ,"",2400,0,8,1,0,1,
   "KSM+"          ,"48 21 29 26"   ,"",2400,0,8,1,0,1,
   "QBBS 2400"     ,"46 23 01 54"   ,"",2400,0,8,1,0,1,
   "QBBS 2400"     ,"46 23 01 55"   ,"",2400,0,8,1,0,1,
   "LINN"          ,"46 55 37 91"   ,"",2400,0,8,1,0,1,
   "SOS-MICRO"     ,"46 21 32 70"   ,"",1200,0,8,1,0,1,
   "OUFLOG"        ,"47 83 33 83"   ,"", 300,0,8,1,0,0,
   "LI LL BBS"     ,"40 82 90 96"   ,"",2400,0,8,1,0,1,



  /*-------------------- Les Commandes Souris    --*/
  "APPEL   "   ,   "",
  "RACCROCH"   ,   "",
  "FIN     "   ,   "",
  "LOG     "   ,   "",
  "CLS     "   ,   "",
  "AIDE    "   ,   "",
  "BACK    "   ,   "",
  "ECRAN   "   ,   "",

  "TTY     "   ,   "",
  "ANSI    "   ,   "",
  "QNX     "   ,   "",
  "MINITEL "   ,   "",
  "HEURE   "   ,   "",
  "SYSTEME "   ,   "",
  "Bloc txt"   ,   "",
  "reconfig"   ,   "",

  "Dialogue"   ,   "*DIA^SA" ,
  "Bal     "   ,   "*BAL^SA" ,
  ""   ,   "",
  ""   ,   "",
  ""   ,   "",
  ""   ,   "",
  ""   ,   "",
  ""   ,   "",

  ""   ,   "",
  ""   ,   "",
  ""   ,   "",
  ""   ,   "",
  ""   ,   "",
  ""   ,   "",
  ""   ,   "",
  ""   ,   "",
   };


/*------------------- FIN D'INIT DE LA STRUCTURE --(pour AlpHaCom )---------*/
#endif




/*---------------------------------------------------------------------------*/
/*
     A Partir de la version 1.8,ca a change, la config est ecrite a la
     fin du programme plutot qu'au milieu.
*/

int WriteConf(char *programme)
   {
   int fichier;                               /* handle fichier             */
   int test;
   long Program_Taille;

   #ifdef __TURBOC__
   struct ftime datefich;
   #else
   unsigned DateFich,
            TimeFich;
   #endif

   printf("\n        REINST:Ecriture de MA Config PERSO dans %s ...\n"
             ,programme);

   fichier=open(programme,O_RDWR|O_BINARY,S_IREAD|S_IWRITE);
   if(fichier==-1)return(0);               /* mais c'est peu probable...*/

   #ifdef __TURBOC__
   getftime(fichier,&datefich);            /* conserve la date du fichier ! */
   #else
   _dos_getftime(fichier,&DateFich,&TimeFich);


   #endif


   Program_Taille=filelength(fichier);           /* prend la taille */
                                            /* Je vais au bon endroit...    */

printf("Taille programme: %ld\n",Program_Taille);
printf("Taille config   : %ld\n",(long) sizeof(Config));

   test=lseek(fichier,Program_Taille - (long)sizeof(Config),SEEK_SET);
   if(test==-1)
     {
      puts(" Erreur dans Seek.\n");
      exit(3);
     }
   time( &Config.CompilTime );  /* Met la date de compilation en place */
   Config.CrcTest = calcrc(&Config.AboName[0],82);

   write(fichier,(char *)&Config.RepereZone[0],sizeof(Config));
                                             /* Je patche le programme...    */
   #ifdef __TURBOC__
   setftime(fichier,&datefich);              /* Et je remets la bonne date,  */
   #else
   _dos_setftime(fichier,DateFich,TimeFich);
   #endif
   close(fichier);                           /* ma bonne dame !              */
   printf("Voil, vieux.\n");
   return(1);
  }
/*---------------------------------------------------------------------------*/


aide()
{
#ifndef BBTH
  printf("**    ATTENTION ! COMPILE POUR ALPHACOM !!! **\n\n");
#endif
printf("REINST: Pour version %d de la struct. de config !\n",STRUVER);
puts("\nSyntaxe:reinst bbth.exe\n\n\n"
       "Initialise le fichier xcutable Bbth avec une configuration\n"
       "par dfaut.   Bbth doit dja tre install !\n\n"
       "La config se modifie en modifiant le source de ce programme,\n"
       "ne pas oublier de compiler en modle LARGE svp (pointeurs..)\n\n\n");
}

/*---------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------*/
/*

      Calcul du crc:extrait de la documentation de Chuck Forsberg

         Figure 8.  Example of CRC Calculation written in C


    This function calculates the CRC used by the XMODEM/CRC Protocol
    The first argument is a pointer to the message block.
    The second argument is the number of bytes in the message block.
    The function returns an integer which contains the CRC.
    The low order 16 bits are the coefficients of the CRC.
*/

   int calcrc(char *ptr, int count)
   {
       int crc, i;

       crc = 0;
       while(--count >= 0)
           {
           crc = crc ^ (int)*ptr++ << 8;
           for(i = 0; i < 8; ++i)
               if(crc & 0x8000)
                   crc = crc << 1 ^ 0x1021;
               else
                   crc = crc << 1;
           }
       return (crc & 0xFFFF);
   }

/*--------------------------------------------------------------------------*/


main(int argc,char **argv)
{
#ifdef __TURBOC__
  directvideo = 1;
#endif

if( argc <2)
  {
   aide();
   return(1);
  }
if( ! WriteConf(argv[1]) )
  {
   printf("\nAbruti ! Connard ! Andouille ! Reflechis un peu !\n\n");
   printf("Je ne vois pas de fichier '%s' ,moi !!!\n\n",argv[1]);
   return(2);
  }
 return(0);
}
